const router = require('express').Router();
const pug = require('pug');
const bcrypt = require('bcrypt');

const saltRounds = 7;

const registerHtml = pug.renderFile('pug/register.pug');

module.exports = User => router
  .get('/register', (req, res) => {
    res.send(registerHtml);
  })
  .post('/register', (req, res) => {
    bcrypt.hash(req.body.password, saltRounds, (err, hash) => {
      if (err) {
        throw err;
      }
      User
        .findCreateFind({ where: { pseudo: req.body.username }, defaults: { mdp: hash } })
        .then(([user, created]) => {
          if (created) {
            res.redirect('/');
          } else {
            res.redirect('back');
          }
        });
    });
  });